<?php

/*
Written by Chris Jean for iThemes.com
Version 0.0.2

Version History
	0.0.1 - 2010-07-20
		Old file name, new code
	0.0.2 - 2011-01-14
		Fixed error when file stylesheet file cannot be saved.
*/


if ( ! class_exists( 'BuilderStyleMangerGenerator' ) ) {
	class BuilderStyleManagerGenerator {
		var $_var = 'builder_style_manager';
		
		
		function delete_stylesheet( $id ) {
			if ( ! isset( $this->_options ) ) {
				$this->_storage =& new ITStorage( $this->_var, true );
				$this->_options = $this->_storage->load();
			}
			
			if ( isset( $this->_options['files'][$id]['file'] ) )
				unlink( $this->_options['files'][$id]['file'] );
			
			unset( $this->_options['files'][$id] );
			$this->_storage->save( $this->_options );
		}
		
		function generate_stylesheet( $id ) {
			if ( ! isset( $this->_options ) ) {
				$this->_storage =& new ITStorage( $this->_var, true );
				$this->_options = $this->_storage->load();
			}
			
			$stylesheet = "/* Standardize child theme styling */\n";
			$stylesheet .= file_get_contents( dirname( __FILE__ ) . '/css/normalize-styling.css' );
			
			$stylesheet .= "\n\n/* Style Manager output */\n";
			$stylesheet .= $this->_options['styles'][$id]['builder_css_preview'];
			
			$version = ( ! empty( $this->_options['files'][$id]['version'] ) ) ? $this->_options['files'][$id]['version'] : 0;
			
			unset( $this->_options['files'][$id] );
			
			if ( ( $uploads = wp_upload_dir() ) && ( false === $uploads['error'] ) ) {
				$filename = wp_unique_filename( $uploads['basedir'], "builder-style-$id.css" );
				$filepath = $uploads['basedir'] . "/$filename";
				
				if ( false !== ( $file_handle = @fopen( $filepath, 'w' ) ) ) {
					fwrite( $file_handle, $stylesheet );
					fclose( $file_handle);
					
					$stat = stat( dirname( $filepath ));
					$perms = $stat['mode'] & 0000666;
					@chmod( $filepath, $perms );
					
					$url = $uploads['baseurl'] . "/$filename";
					
					$this->_options['files'][$id]['file'] = $filepath;
					$this->_options['files'][$id]['url'] = $url;
					$this->_options['files'][$id]['version'] = $version + 1;
				}
			}
			
			if ( ! isset( $this->_options['files'][$id] ) )
				$this->_options['files'][$id]['stylesheet'] = $stylesheet;
			
			$this->_storage->save( $this->_options );
			
			
			return $this->_options['files'][$id];
		}
	}
}


?>
